#ifdef GL_ES
  #define LOWP lowp
  precision mediump float;
#else
  #define LOWP
#endif

varying LOWP vec4 v_color;
varying vec2 v_texCoords;

uniform sampler2D u_texture;
uniform vec4 u_mask;
uniform vec4 u_replaceColor;

void main() {
    vec4 resultColor = texture2D(u_texture, v_texCoords) * v_color;

    float mixFactor = step(0.001, distance(u_mask, resultColor));
    resultColor = mix(u_replaceColor, resultColor, mixFactor);

    gl_FragColor = resultColor;
}